# !/usr/bin/env python

#import roslib
import rospy #Para escribir un nodo de ROS en pythoni
import time
from std_msgs.msg import String #para usar el tipo de mensaje String
from geometry_msgs.msg import Twist #para usar el tipo de mensaje Twist (velocidad)
from kobuki_msgs.msg import BumperEvent #para usar el tipo de mensaje BumperEvent (sensores de presion)
from math import radians

class bumpernode():
	colision = 0
	actual = 0
	angulo = 0
	move_cmd = Twist()
	colision_cmd = Twist()

    def __init__(self): #self representa la instancia del objeto en si mismo
        
       	#Mensaje que obtenemos por pantalla
        rospy.loginfo('Programa choques')
        
       	#Funcion que llamamos si terminamos el programa (ctrl+c)
        rospy.on_shutdown(self.shutdown)
        
       	#Suscriber que lee datos del parachoques
       	#Se subscribe al topic '/mobile_base/events/bumper' usando el tipo de mensaje BumperEvent
       	#callback es la funcion a la que se llamara al recibir el mensaje en el topic
        rospy.Subscriber('/mobile_base/events/bumper', BumperEvent, self.callback)
        
       	#Publisher que se encarga de los movimientos del robot
        #Va a publicar en el topic cmd_vel_mux/input/navi, encargado del movimiento de la turtlebot, el tipo de mensaje Twist
       	#queue_size limita el numero de mensajes en cola si algun subscriptor no esta recibiendo los mensajes suficientemente rapido
        self.turtle_vel = rospy.Publisher('cmd_vel_mux/input/navi', Twist, queue_size=10)
        
    def navegar(self):
        self.move_cmd.linear.x = 0.2 #velocidad publicada si no hay choque
        self.colision_cmd.linear.x = -0.1 #velocidad publicada si hay choque
        if self.colision == 0:
            self.turtle_vel.publish(self.move_cmd) #si no hay choque va hacia delante
        else:
            self.colision_cmd.angular.z = radians(self.angulo)
            self.turtle_vel.publish(self.colision_cmd) #si hay choque va hacia atras y gira
            if time.time()-self.actual>2: #esto lo hace durante 2seg desde el choque
				self.colision = 0
				self.actual = 0

	#Funcion que se reproduce cada vez que hay una colision
        #data es el mensaje que recibe BumperEvent
    def callback(self,data):
        if data.state == 1: #Si es un 1, significa que hay colision
			self.colision = 1
			self.actual = time.time() #Guarda el instante del choque 
			if data.bumper == 0: #colision por la izquierda
				print "COLISION IZQUIERDA"
				self.angulo = -15
			elif data.bumper == 1: #colision por el centro
				print "COLISION CENTRAL"
				self.angulo = -45
			elif data.bumper == 2:
				print "COLISION DERECHA" #colision por la derecha
				self.angulo = 15
						
        def shutdown (self):
        	rospy.loginfo("STOP TURTLEBOT")
        	print "Saliendo..."
                self.turtle_vel.publish(Twist()) #Paramos el robot
                rospy.sleep(5) #Esperamos a que se detenga para salir.
        
if __name__ == '__main__':
	try:
		rospy.init_node('bumpernode',anonymous=True)
		explorer = bumpernode()
		while not rospy.is_shutdown():
			explorer.navegar() #navega en bucle mientras no paremos el programa
	except:
		rospy.loginfo ("bumpernode node terminated")
