#!/usr/bin/env python
import rospy
from geometry_msgs.msg import PointStamped
from datetime import datetime
from math import *

class Meta():
	x = []
	y = []

#Constructor	
	def __init__(self):
		rospy.on_shutdown(self.shutdown)
		rospy.Subscriber('/clicked_point', PointStamped, self.callback) #subscriptor a los mensajes del topic clicked_point

#Funcion encargada de generar el cuaternio con la orientacion
	def orientacion(self,x1,y1,x2,y2):
		quat = [] 
		v = [x2-x1,y2-y1] #vector de direccion del eje x nuevo
		productoescalar = v[0]*1+v[1]*0 #producto escalar entre la direccion nueva del eje x y la direccion del eje x de la base (1,0)
		mod_v = sqrt(v[0]*v[0] + v[1]*v[1]) #modulo del vector
		ang = acos(productoescalar/mod_v) #angulo entre los dos vectores arccos(productoescalar/producto de modulos) en radianes
		quat = [cos(ang/2),0,0,sin(ang/2)] #cuaternio = [q0,q1,q2,q3] siendo q0 la componente escalar
		self.x[:] = [] #borra el vector x para los siguientes puntos
		self.y[:] = [] #borra el vector y para los siguientes puntos 
		return quat

#Funcion que es llamada cuando se recibe un mensaje del topic clicked_point
	def callback(self,msg): 
		rospy.loginfo("coordinates:x=%f y=%f" %(msg.point.x,msg.point.y))
		self.x.append(msg.point.x) #Guarda la posicion x en el vector x
		self.y.append(msg.point.y) #Guarda la posicion y en el vector y 

#Funcion encargada de escrbir en el fichero 
	def escribefichero(self,x,y,cuaternio):
		f = open("/home/tb2/catkin_ws/src/scheduleposition/scripts/Schedule.txt", "a") #Abre el fichero de la ruta en modo escritura
		f.write(datetime.now().strftime('%H:%M')) #Escribe fecha actual en formato HORA:MINUTOS
 		f.write(";")
		f.write(str(x))  
		f.write(";")
		f.write(str(y)) 
		f.write(";")
		f.write(str(cuaternio[0]))
		f.write(";")
		f.write(str(cuaternio[1]))
		f.write(";")
		f.write(str(cuaternio[2]))
		f.write(";")
		f.write(str(cuaternio[3]))
		f.write("\n")
		f.close()

#Funcion que va a ser llamada en bucle
	def main(self):
		if(len(self.x) == 2): #Si el tamaño de la lista x es 2 significa que se han obtenido dos puntos
			posx = self.x[0] #la posicion es el primer punto 
			posy = self.y[0]
			cuaternio = self.orientacion(self.x[0],self.y[0],self.x[1],self.y[1]) #con los dos puntos se haya el cuaternio 
			print cuaternio 
			self.escribefichero(posx,posy,cuaternio) #lo escribe en el fichero 

#Funcion llamada cuando se cierra el programa
	def shutdown(self):
                rospy.loginfo("Ctrl-C caught. Quitting")

if __name__ == '__main__':
    	try:
		escribe = Meta() #Crea objeto
		while not rospy.is_shutdown():
			rospy.init_node('goal_publisher', anonymous=True) #inicia nodo
			escribe.main() #funcion main en bucle mientras no se cierre el programa 
			rospy.sleep(1)
	except rospy.ROSInterruptException:
                rospy.loginfo("Ctrl-C caught. Quitting")

